core:module("CoreViewportManager")

local mvec3_set_y = mvector3.set_y
local mvec3_y = mvector3.y

local new_vp_orig = ViewportManager.new_vp
function ViewportManager:new_vp(...)
	local svp = new_vp_orig(self, ...)

	local meta = getmetatable(svp)
	local set_camera_orig = meta.set_camera
	function meta:set_camera(...)
		local meta = getmetatable(self)
		if not meta.setup_mirrored then
			local world_to_screen_orig = meta.world_to_screen
			function meta.world_to_screen(...)
				local screen_pos = world_to_screen_orig(...)
				local res_y = mvec3_y(RenderSettings.resolution)
				local screen_y = -(mvec3_y(screen_pos) - res_y)

				mvec3_set_y(screen_pos, screen_y)

				return screen_pos
			end

			meta.setup_mirrored = true
		end

		return set_camera_orig(self, ...)
	end

	return svp
end